InitSprite()
InitSprite3D()
InitKeyboard()
InitSound()
InitMovie()

Procedure BoxKolli(X1,Y1,W1,H1,  X2,Y2,W2,H2)
  If X1<X2+W2 And X1+W1>X2
    If Y1<Y2+H2 And Y1+H1>Y2
    ProcedureReturn 1
    EndIf
  EndIf
ProcedureReturn 0
EndProcedure


#W=16
#H=16

;Leveldata
Dim Feld(#W,#H)

Feld(12,9)=4
Feld(10,9)=1
Feld(3,10)=3
Feld(5,10)=5

For i=0 To 10 Step 1
 Feld(i,11)=1
Next

For i=10 To 16 Step 1
 Feld(i,11)=2
Next


OpenWindow(0,0,0,1024,768,"Basic Ghost v1.3",#PB_Window_ScreenCentered | #PB_Window_SystemMenu)
OpenWindowedScreen(WindowID(0),0,0,1024,768,0,0,0)


;Sound
LoadSound(0,"sfx\jump.wav")

LoadSound(1,"sfx\coin.wav")

LoadSound(2,"sfx\pipe.wav")

LoadSound(3,"sfx\1-up.wav")

LoadSound(4,"sfx\gameover.wav")

LoadSound(5,"sfx\crack.wav")

LoadMovie(0,"sfx\music\background-1.mid")

;Sprites
LoadSprite(0,"gfx\player-1.bmp",0)
TransparentSpriteColor(0,RGB(1,1,1))

LoadSprite(1,"gfx\stone.bmp",0)
TransparentSpriteColor(1,$FFFFFF)

LoadSprite(4,"gfx\quest.bmp", 0 | #PB_Sprite_Texture)
TransparentSpriteColor(4,$FFFFFF)

LoadSprite(5,"gfx\cloud-1.bmp",0)
TransparentSpriteColor(5,0)

LoadSprite(6,"gfx\stone-break.bmp",0)
TransparentSpriteColor(6,$FFFFFF)

LoadSprite(7,"gfx\cloud-2.bmp",0)
TransparentSpriteColor(7,0)

LoadSprite(8,"gfx\coin.bmp",0)
TransparentSpriteColor(8,$FFFFFF)

LoadSprite(9,"gfx\enemy.bmp",0)
TransparentSpriteColor(9,RGB(100,100,100))

LoadSprite(10,"gfx\pipe.bmp",0)
TransparentSpriteColor(10,$FFFFFF)

LoadSprite(11,"gfx\heart.bmp",0)
TransparentSpriteColor(11,$FFFFFF)

LoadSprite(12,"gfx\bush-1.bmp",0)
TransparentSpriteColor(12,$FFFFFF)

LoadSprite(13,"gfx\bush-2.bmp",0)
TransparentSpriteColor(13,$FFFFFF)

LoadSprite(14,"gfx\player-2.bmp",0)
TransparentSpriteColor(14,RGB(1,1,1))

LoadSprite(15,"gfx\empty.bmp",0)
TransparentSpriteColor(15,RGB(100,0,255))

CreateSprite3D(0,4)


;Variables
Define.l PlayerX,PlayerY
Define.f MoveX,MoveY
Define.b OnGround
Define.l EnemyX,EnemyY

PlayerW=SpriteWidth(0) 
PlayerH=SpriteHeight(0)

TileW=64
TileH=64

movie=0
timer=0

life=12
coin=0

EnemyY=670

PlayMovie(movie,WindowID(0))


Repeat 
 
  Event= WindowEvent()  
  
  ExamineKeyboard()
  
    If KeyboardPushed(#PB_Key_Escape)  
    End
    EndIf
    
    If MovieStatus(movie) = 0
     PlayMovie(movie, WindowID(0))
    EndIf    
 
    MoveX=0
    MoveY+0.5   
    
    EnemyX=EnemyX+1
    If EnemyX>1024
       EnemyX=0
    EndIf
    
    If KeyboardPushed(#PB_Key_Left)
    MoveX-5
    EndIf
    
    If KeyboardPushed(#PB_Key_Right)
    MoveX+5
    EndIf
   
    If OnGround=1
      MoveY=0
      If KeyboardPushed(#PB_Key_Space)
      MoveY=-15
      PlaySound(0) 

      EndIf
    EndIf
    
    PlayerX+MoveX
    PlayerY+MoveY
  
    OnGround=0
    Hit=0
    ClearScreen(RGB(100,0,255))   

    For x=0 To #W
      For y=0 To #H      
   
     If BoxKolli(x*TileW,y*TileH,TileW,TileH,PlayerX,PlayerY,PlayerW,PlayerH)        
       Select Feld(x,y)
          Case 1
          OnGround=1
          PlayerY=Y*TileH-SpriteHeight(0) 
            If MoveY<0; 
              MoveY=0
              PlayerY=Y*TileH+TileH;Untere Seite
              Onground=0
            EndIf
          
          Case 2
          Onground=1
          Feld(x,y)=0
          PlaySound(5)
          
          Case 3  
          Feld(x,y)=0
          PlaySound(1)
          coin+1
          
          Case 4
          Feld(x,y)=0
          PlaySound(3)
          life+1
          
          Case 5
          Feld(x,y)=0
          PlaySound(3)
          life=20
          
         EndSelect
       EndIf              
     
      Next y
    Next x
 
    ;**********Drawing**********            
    DisplayTransparentSprite(12,450,530)
    DisplayTransparentSprite(13,200,530)
    
    
    For x=0 To #W
      For y=0 To #H
        Select Feld(x,y)
          Case 1
          DisplayTransparentSprite(1,x*TileW,y*TileH)
          
          Case 2
          DisplayTransparentSprite(6,x*TileW,y*TileH)
   
          Case 3
          DisplayTransparentSprite(8,x*TileW,y*TileH)
          
          Case 4 
          DisplayTransparentSprite(11,x*TileW,y*TileH)
          
          Case 5
          DisplayTranslucentSprite(15,x*TileW,y*TileH,0)
          
          Start3D()
            Sprite3DQuality( #PB_Sprite3D_BilinearFiltering)
            DisplaySprite3D(0,x*TileW,y*TileH)
            RotateSprite3D(0,-1,#PB_Relative)
          Stop3D()         
                  
        EndSelect        
      Next y
    Next x  
  

  ;++++++++++Display++++++++++
  DisplayTransparentSprite(0,PlayerX,PlayerY)
  
  DisplayTransparentSprite(5,280,340)
  
  DisplayTransparentSprite(7,700,150)
  
  DisplayTransparentSprite(9,EnemyX,EnemyY)
  
  DisplayTransparentSprite(10,448,641)

  DisplayTransparentSprite(8,160,78)  ;coins
  
  StartDrawing(WindowOutput(0))
     DrawingMode(#PB_2DDrawing_Transparent)  
     DrawText(100,100,"Lifes:"+Str(life))
     DrawText(200,100,"x  "+Str(coin))
  StopDrawing()

  If SpriteCollision(0,PlayerX,PlayerY,10,448,641)=1 
     If KeyboardPushed(#PB_Key_Right)
        PlaySound(2)
        PlayerX=448+SpriteWidth(10)
     EndIf
     
     If KeyboardPushed(#PB_Key_Left)
        PlaySound(2)
        PlayerX=448-SpriteWidth(0)
     EndIf
  EndIf
    
  
  If SpriteCollision(0,PlayerX,PlayerY,9,EnemyX,EnemyY)=1
     DisplayTransparentSprite(14,PlayerX,PlayerY)
     timer=timer+1
     If timer>=10
        life=life-1
        timer=0
     EndIf
  EndIf
    
  FlipBuffers()
  
  If life=0
     StopMovie(movie)
     Delay(500)
     PlaySound(4)
     MessageRequester("Info","Game Over")  
     End       
  EndIf
   
 If PlayerY>768      
    PlayerX=0
    PlayerY=0
    MoveY=0
    life-1    
 EndIf
 
 If life>20
    life=20
 EndIf   
   
 If KeyboardReleased(#PB_Key_R)
    PlayerX=0
    PlayerY=0
    MoveY=0
 EndIf
  
  If Event=#PB_Event_CloseWindow
     CloseWindow(0)
  EndIf

  Until Event=#PB_Event_CloseWindow
; IDE Options = PureBasic 4.41 (Windows - x64)
; CursorPosition = 25
; Folding = +
; Executable = ..\Basic Ghost.exe